module Saper
  
  require 'bundler/setup'
  require 'reverse_markdown'
  require 'json'
  require 'vremya'
  require 'nokogiri'
  require 'securerandom'
  require 'mechanize'
  require 'jpath'

  require_relative "saper/patches/mechanize"
  require_relative "saper/patches/nokogiri"
  require_relative "saper/version"

  require_relative "saper/core/action"
  require_relative "saper/core/argument"
  require_relative "saper/core/browser"
  require_relative "saper/core/dsl"
  require_relative "saper/core/error"
  require_relative "saper/core/item"
  require_relative "saper/core/keychain"
  require_relative "saper/core/logger"
  require_relative "saper/core/namespace"
  require_relative "saper/core/recipe"
  require_relative "saper/core/result"
  require_relative "saper/core/runtime"
  require_relative "saper/core/stack"
  require_relative "saper/core/type"
  
  require_relative "saper/arguments/attribute"
  require_relative "saper/arguments/recipe"
  require_relative "saper/arguments/service"
  require_relative "saper/arguments/text"
  require_relative "saper/arguments/timezone"
  require_relative "saper/arguments/url"
  require_relative "saper/arguments/variable"
  require_relative "saper/arguments/xpath"
  
  require_relative "saper/items/atom"
  require_relative "saper/items/document"
  require_relative "saper/items/html"
  require_relative "saper/items/json"
  require_relative "saper/items/markdown"
  require_relative "saper/items/nothing"
  require_relative "saper/items/text"
  require_relative "saper/items/time"
  require_relative "saper/items/url"
  require_relative "saper/items/xml"
  
  require_relative "saper/actions/append_with"
  require_relative "saper/actions/convert_to_html"
  require_relative "saper/actions/convert_to_json"
  require_relative "saper/actions/convert_to_markdown"
  require_relative "saper/actions/convert_to_time"
  require_relative "saper/actions/convert_to_xml"
  require_relative "saper/actions/create_atom"
  require_relative "saper/actions/fetch"
  require_relative "saper/actions/fetch_with_token"
  require_relative "saper/actions/find"
  require_relative "saper/actions/find_first"
  require_relative "saper/actions/get_attribute"
  require_relative "saper/actions/get_contents"
  require_relative "saper/actions/get_text"
  require_relative "saper/actions/nothing"
  require_relative "saper/actions/prepend_with"
  require_relative "saper/actions/remove_after"
  require_relative "saper/actions/remove_before"
  require_relative "saper/actions/remove_matching"
  require_relative "saper/actions/remove_tags"
  require_relative "saper/actions/replace"
  require_relative "saper/actions/run_recipe"
  require_relative "saper/actions/run_recipe_and_save"
  require_relative "saper/actions/save"
  require_relative "saper/actions/select_matching"
  require_relative "saper/actions/set_input"
  require_relative "saper/actions/skip_tags"
  require_relative "saper/actions/split"
  
end
