module Saper
  module Actions
    class ConvertToTime < Action
      
      argument :text
      argument :text, :optional => true
      accepts :text, :returns => :time
      
      run do |runtime, input, format, tz|
        tz = nil if tz && tz.empty?
        input.to_time(format, tz)
      end
      
      # Format elements
      # %Y  - Year with century (can be negative, 4 digits at least)
      # %C  - year / 100 (round down.  20 in 2009)
      # %y  - year % 100 (00..99)
      # %m  - Month of the year, zero-padded (01..12)
      # %-m - Month of the year, no-padded (1..12)
      # %B  - The full month name (``January'')
      # %^B - Month name uppercased (``JANUARY'')
      # %b  - Abbreviated month name (``Jan'')
      # %^b - Abbreviated uppercased month (``JAN'')
      # %d  - Day of the month, zero-padded (01..31)
      # %-d - Day of the month, no-padded (1..31)
      # %e  - Day of the month, blank-padded ( 1..31)
      # %j  - Day of the year (001..366)
      # %H  - Hour of the day, 24-hour clock, zero-padded (00..23)
      # %k  - Hour of the day, 24-hour clock, blank-padded ( 0..23)
      # %I  - Hour of the day, 12-hour clock, zero-padded (01..12)
      # %l  - Hour of the day, 12-hour clock, blank-padded ( 1..12)
      # %P  - Meridian indicator, lowercase (``am'' or ``pm'')
      # %p  - Meridian indicator, uppercase (``AM'' or ``PM'')
      # %M  - Minute of the hour (00..59)
      # %S  - Second of the minute (00..59)
      # %L  - Millisecond of the second (000..999)
      # %N  - Fractional seconds digits, default is 9 digits (nanosecond)
      # %z  - Time zone as hour and minute offset from UTC (e.g. +0900)
      # %:z - hour and minute offset from UTC with a colon (e.g. +09:00)
      # %Z  - Time zone abbreviation name
      # %A  - The full weekday name (``Sunday'')
      # %^A - Weekday, uppercased (``SUNDAY'')
      # %a  - Weekday, abbreviated (``Sun'')
      # %^a - Weekday, uppercased (``SUN'')
      # %u  - Day of the week (Monday is 1, 1..7)
      # %w  - Day of the week (Sunday is 0, 0..6)
      # %s  - Number of seconds since 1970-01-01 00:00:00 UTC.
      # %Q  - Number of milliseconds since 1970-01-01 00:00:00 UTC.
      
    end
  end
end
