module Saper
  module Actions
    class Split < Action
      
      returns_multiple_items!
      argument :text
      accepts :text, :returns => :text
      accepts :document, :returns => :text
      accepts :html, :returns => :html
      
      run do |runtime, input, separator|
        case input
        when Items::HTML
          input.inner_html.split(separator).map { |string| Item.new(:text, string).to_html }
        when Items::Text
          input.split(separator)
        when Items::Document
          input.to_text.split(separator)
        end
      end
      
    end
  end
end
