module Saper
  class Keychain
    
    # @todo
    def self.load(path, options = {})
      case File.extname(path)
      when '.yaml'
        load_yaml(path)
      when '.yml'
        load_yaml(path)
      when '.json'
        load_json(path)
      else
        nil
      end
    end
    
    # @todo
    def self.load_yaml(path)
      new YAML.load_file(path)
    rescue
      nil
    end
    
    # @todo
    def self.load_json(path)
      new JSON.parse(IO.read(path), :symbolize_names => true)
    rescue
      nil
    end
    
    # Returns a new keychain instance
    # @return [Saper::Keychain]
    def initialize(services = {}, options = {})
      @services = Hash[services.map { |k,v| [k.to_s, v] }]
    end
    
    # Returns access credentials for the specified service.
    # @param service [String, Symbol] service name
    # @return [Hash, nil]
    def [](service)
      @services[service.to_s] || {}
    end
    
    # @todo
    def login(service)
      self[service][:login]
    end
    
    # @todo
    def password(service)
      self[service][:password]
    end
    
    # @todo
    def token(service)
      self[service][:token]
    end
    
    # @todo
    def has?(service)
      !self[service].empty?
    end
    
    # @todo
    def services
      @services.keys.select { |service| has?(service) }
    end
    
  end
end
