module Saper
  class Result
    
    # @todo
    attr_reader :stacks
    
    # @todo
    attr_reader :duration
    
    # @todo
    def initialize(stacks = [])
      started   = Time.now
      @stacks   = stacks.to_a
      @duration = Time.now - started
      if block_given?
        yield self
      end
    end
    
    # @todo
    def http_requests
      browser.requests
    end
    
    # @todo
    def bytes_sent
      browser.sent
    end
    
    # @todo
    def bytes_received
      browser.received
    end
    
    # @todo
    def success?
      not failure?
    end
    
    # @todo
    def failure?
      filtered_stacks.all?(&:error?)
    end
    
    # @todo
    def size
      stacks.size
    end
    
    # @todo
    def multiple?
      size > 1
    end
    
    # @todo
    def to_saper_array
      filtered_stacks.map(&:result)
    end
    
    # @todo
    def to_native_array
      to_saper_array.map { |i| i.is_a?(Saper::Item) ? i.to_native : i }
    end
    
    # @todo
    def to_serialized_array
      to_saper_array.map { |i| i.is_a?(Saper::Item) ? i.serialize : i }
    end
    
    # @todo
    def to_saper
      multiple? ? to_saper_array : to_saper_array.first
    end
    
    # @todo
    def to_native
      multiple? ? to_native_array : to_native_array.first
    end
    
    # @todo
    def serialize
      multiple? ? to_serialized_array : to_serialized_array.first
    end
    
    # Returns runtime results as JSON.
    # @return [Array]
    def to_json(*args)
      JSON.dump(serialize)
    end
    
    private
    
    def filtered_stacks
      stacks.reject(&:filtered?)
    end
    
    # @todo
    def browser
      stacks.first.runtime.browser
    end
    
  end
end