module Saper
  module Items
    class Document < Item
      
      # @todo
      attr_reader :body
      
      # @todo
      attr_reader :uri
      
      # @todo
      attr_reader :headers
      
      # @todo
      def self.new(body, uri = nil, headers = {})
        unless body.is_a?(String)
          raise(InvalidItem)
        end
        unless headers.is_a?(Hash)
          raise(InvalidItem)
        end
        super
      end
      
      # @todo
      def initialize(body, uri = nil, headers = {})
        @uri     = (uri.nil? ? nil : uri.to_s)
        @body    = body
        @headers = headers
      end
      
      # @todo
      def size
        body.size
      end
      
      # @todo
      def mime
        content_type.split(";").first
      end
      
      # @todo
      def charset
        content_type.include?("charset=") ? content_type.split("charset=").last : nil
      end
      
      # @todo
      def to_text
        Text.new(body)
      end
      
      # @todo
      def to_html
        HTML.new(self)
      end
      
      # @todo
      def to_xml
        XML.new(body)
      end
      
      # @todo
      def to_json
        JSON.new(body)
      end
      
      # @todo
      def to_markdown
        Markdown.new(to_html)
      end
      
      # @todo
      def to_native
        body
      end
      
      def to_s
        to_native
      end
      
      private
      
      # @todo
      def content_type
        headers['content-type'] || ""
      end
      
    end
  end
end