module Saper
  module Items
    class JSON < Item
      
      # @todo
      def self.new(item, bypass = false)
        super case item
        when Text
          parse(item.to_s)
        when String
          parse(item)
        when Hash
          bypass ? item : raise(InvalidItem, item)
        else
          raise(InvalidItem, item)
        end
      end
      
      # @todo
      def self.parse(string)
        begin
          ::JSON.parse(string)
        rescue
          raise(InvalidItem, string)
        end
      end
      
      # @todo
      def initialize(hash)
        @hash = hash
      end
      
      # @todo
      def ==(other)
        @hash == other
      end
      
      # @todo
      def find(xpath)
        find_all(xpath).first
      end
      
      # @todo
      def find_all(xpath)
        sanitize JPath.find(@hash, xpath)
      end
      
      # @todo
      def to_s
        ::JSON.dump(@hash)
      end
      
      # @todo
      def to_json(*a)
        a.empty? ? self : @hash
      end
      
      # @todo
      def to_native
        to_s
      end
      
      private
      
      # @todo
      def sanitize(item)
        case item
          when Hash
            self.class.new(item, true)
          when Array
            item.map { |i| sanitize(i) }
          else
            Text.new(item.to_s)
        end
      end
      
    end
  end
end