# Monkey patching Mechanize
# - allow custom pre_connect_hooks and post_connect_hooks

class Mechanize
  
  def pre_connect_hook(&block)
    @agent.pre_connect_hook(&block)
  end
  
  def post_connect_hook(&block)
    @agent.post_connect_hook(&block)
  end
  
end

class Mechanize::HTTP::Agent
  
  def pre_connect_hook(&block)
    @pre_connect_hooks << block
  end

  def post_connect_hook(&block)
    @post_connect_hooks << block
  end
  
end