module Tungsten
  class Headers
    
    include Enumerable
    
    def initialize(hash)
      @hash = hash
    end
    
    def has?(name)
      @hash.key?(name.downcase)
    end
    
    def [](name)
      has?(name) ? @hash[name.downcase].join(', ') : nil
    end
    
    def each(&block)
      @hash.each { |k,v| yield capitalize(k), v.join(', ') }
    end
    
    def to_s
      map { |k,v| "%s: %s" % [k, self[k]] }.join("\n")
    end
    
    def size
      to_s.size
    end
    
    private
    
    def capitalize(name)
      name.split(/-/).map {|s| s.capitalize }.join('-')
    end
    
  end
end
